'From Squeak3.9 of 7 November 2006 [latest update: #7067] on 30 March 2008 at 4:21:17 pm'!
"Change Set:		FFI-64BitUpdates-Tests-dtl
Date:			30 March 2008
Author:			David T. Lewis

Updates to FFI tests to provide coverage of FFI primitives."!


!FFIPluginTests methodsFor: 'primitive tests' stamp: 'dtl 3/30/2008 12:21'!
testPrimitiveAllocateAndFree

	| tp w |
	tp := FFITestPoint4 externalNew. "uses primitiveFFIAllocate"
	[w := tp w.
	self assert: w = 0.
	tp w: 4.
	w := tp w.
	self assert: w = 4]
		ensure: [tp free "uses primitiveFFIFree"]! !

!FFIPluginTests methodsFor: 'primitive tests' stamp: 'dtl 3/30/2008 16:14'!
testPrimitiveDoubleAtPut

	| b |
	b := ByteArray new: 16.
	b doubleAt: 1 put: 1.23456789.
	self assert: ( b doubleAt: 1) = 1.23456789.
	b doubleAt: 9 put: 9.87654321.
	self assert: ( b doubleAt: 1) = 1.23456789.
	self assert: ( b doubleAt: 9) = 9.87654321
! !

!FFIPluginTests methodsFor: 'primitive tests' stamp: 'dtl 3/30/2008 16:16'!
testPrimitiveFloatAtPut

	| b delta |
	delta := 0.000001.
	b := ByteArray new: 16.
	b floatAt: 1 put: 1.2345.
	self assert: ((b floatAt: 1) - 1.2345) < delta.
	b floatAt: 9 put: 9.8765.
	self assert: ((b floatAt: 1) - 1.2345) < delta.
	self assert: ((b floatAt: 9) - 9.8765) < delta.
	b floatAt: 5 put: 5.4321.
	self assert: ((b floatAt: 1) - 1.2345) < delta.
	self assert: ((b floatAt: 9) - 9.8765) < delta.
	self assert: ((b floatAt: 5) - 5.4321) < delta.
	b floatAt: 13 put: 3.4567.
	self assert: ((b floatAt: 1) - 1.2345) < delta.
	self assert: ((b floatAt: 9) - 9.8765) < delta.
	self assert: ((b floatAt: 5) - 5.4321) < delta.
	self assert: ((b floatAt: 13) - 3.4567) < delta
! !

!FFIPluginTests methodsFor: 'primitive tests' stamp: 'dtl 3/30/2008 16:17'!
testPrimitiveForceLoad

	SmalltalkImage current unloadModule: 'SqueakFFIPrims'.
	self assert: (SmalltalkImage current listLoadedModules
					detect: [:e | 'SqueakFFIPrims*' match: e]
					ifNone: []) isNil.
	FFITestLibrary new forceLoading.
	self deny: (SmalltalkImage current listLoadedModules
					detect: [:e | 'SqueakFFIPrims*' match: e]
					ifNone: []) isNil
! !

!FFIPluginTests methodsFor: 'primitive tests' stamp: 'dtl 3/30/2008 16:18'!
testPrimitiveIntegerAtPut

	| b |
	b := ByteArray new: 8.
	self assert: ( b signedLongAt: 1) = 0.
	b signedLongAt: 1 put: 123456789.
	self assert: (b signedLongAt: 1) = 123456789.
	b signedLongAt: 5 put: 9876543.
	self assert: (b signedLongAt: 5) = 9876543.
	b signedLongAt: 5 put: -9876543.
	self assert: (b signedLongAt: 5) = -9876543.
	b signedByteAt: 5 put: 127.
	self assert: (b signedByteAt: 5) = 127.
	self deny: (b signedLongAt: 5) = -9876543.
	b signedLongAt: 5 put: -9876543.
	self deny: (b signedByteAt: 5) = 127.
	b unsignedCharAt: 3 put: $X.
	self assert: (b unsignedCharAt: 3) = $X.
	b unsignedShortAt: 3 put: 12345.
	self assert: (b unsignedShortAt: 3) = 12345.
	b signedShortAt: 3 put: -12345.
	self assert: (b signedShortAt: 3) = -12345
! !


!FFIPluginTests reorganize!
('simple tests' testConstructedCharCall testConstructedDoubleCall testConstructedFloatCall testConstructedIntCall testConstructedPrintString testConstructedShortCall testGenericCharCall testGenericDoubleCall testGenericFloatCall testGenericIntCall testGenericPrintString testGenericShortCall testLibraryCharCall testLibraryDoubleCall testLibraryFloatCall testLibraryIntCall testLibraryPrintString)
('structure tests' testLongLongs testPoint2 testPoint4 testPointers)
('primitive tests' testPrimitiveAllocateAndFree testPrimitiveDoubleAtPut testPrimitiveFloatAtPut testPrimitiveForceLoad testPrimitiveIntegerAtPut)
!

